<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Sign Up - Form</title>

     <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
     <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
</head>

<style>
     .div-background-picture{
          background-image: url("signup-bg.jpg");
          height: 200%;
          background-position: center;
          background-repeat: no-repeat;
          background-size: cover;
          opacity: 0.7;
     }
</style>
<body>
     <div class="container-fluid div-background-picture">
          <form id = "form-login" action = "#" method="post">
               <div class="row d-flex align-items-center min-vh-100">
                    <div class="col-sm-6 text-center mx-auto my-0 jumbotron">
                         <div class="mb-5">
                              <h3 class="text-center">CREATE ACCOUNT</h3>
                         </div>
                         <div>
                              <div class="form-group">
                                   <input id="inp-your-name" type="text" name="name" placeholder="Your Name" class="form-control" value="" autocomplete="username">
                              </div>
                              <div class="form-group">
                                   <input id="inp-your-email" type="email" placeholder="Your Email" class="form-control" value="" autocomplete="username">
                              </div>
                              <div class="form-group">
                                   <input id="inp-password" name="password" placeholder="Password" class="form-control" value="" autocomplete="inp-current-password" type="password">
                              </div>
                              <div class="form-group">
                                   <input id="inp-repeat-password" name="password" placeholder="Repeat your password" class="form-control" value="" autocomplete="inp-repeat-password" type="password">
                              </div>
                              <div class="form-group text-left">
                                   <input type="checkbox" id="check-confirm-accept"> I agree all statements in
                                   <a href="#">Term of service</a>
                              </div>
                              <div class="form-group">
                                   <button type="submit" class="btn btn-log btn-block btn-success" id="btn-sign-up">SIGN UP</button>
                              </div>
                              <br>
                              <br>
                              <div class="form-group">
                                   <p>Have already an account ?<a href="#"> Login here</a></p>
                              </div>
                         </div>
                    </div>
               </div>
          </form>
     </div>
</body>

<script>
     "use strict";
     $(document).ready(function(){
     /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
     const gYOUR_NAME = $("#inp-your-name");
     const gYOUR_EMAIL = $("#inp-your-email");
     const gPASSWORD = $("#inp-password");
     const gREPEAT_PASSWORD = $("#inp-repeat-password");
     const gI_ACCEPT = $("#check-confirm-accept");
     /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
     $("#form-login").on("submit", function(event){
          event.preventDefault();
          onBtnSignUpClick();
     });
     /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
     //hàm xử lý khi nút sign up được nhấn
     function onBtnSignUpClick(){
          var vUserObj = {
               yourName: "", 
               yourEmail: "", 
               password: "", 
               repeatPassword: "", 
               iAgree: true
          }

          //bước 1: thu thập dữ liệu 
               getData(vUserObj);
          //bước 2: kiểm tra dữ liệu 
               var vCheck = validateData(vUserObj);
               if(vCheck){
                    //bước 3: hiển thị dữ liệu 
                    showData(vUserObj);
               }
          
     }
     /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
     //hàm thu thập dữ liệu 
     function getData(paramUserObj){
          paramUserObj.yourName = gYOUR_NAME.val().trim();
          paramUserObj.yourEmail = gYOUR_EMAIL.val().trim();
          paramUserObj.password = gPASSWORD.val().trim();
          paramUserObj.repeatPassword = gREPEAT_PASSWORD.val().trim();
          paramUserObj.iAgree = gI_ACCEPT.val();
     }

     //hàm kiểm tra dữ liệu 
     function validateData(paramUserObj){
          var vRegexStr = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
          if(paramUserObj.yourName == ""){
               alert("Bạn cần nhập Username!!!");
               return false;
          }
          if(paramUserObj.yourEmail == ""){
               alert("Bạn cần nhập Email!!!");
               return false;
          }
          if(!vRegexStr.test(paramUserObj.yourEmail)){
               alert("Email không hợp lệ!!!");
               return false;
          }
          if(paramUserObj.yourEmail.indexOf("@") == -1 || paramUserObj.yourEmail.indexOf("@") == 0 || paramUserObj.yourEmail.indexOf("@") == paramUserObj.yourEmail.length - 1){
               alert("Email không hợp lệ! Email phải có @ và không được nằm ở đầu hoặc cuối");
               return false;
          }
          if(paramUserObj.password.length < 8){
               alert("Password phải dài ít nhất 8 ký tự!");
               return false;
          }
          if(paramUserObj.password == ""){
               alert("Bạn cần nhập Password!!!");
               return false;
          }
          if(paramUserObj.password != paramUserObj.repeatPassword){
               alert("Repeat Password của bạn không khớp với Password ở trên!!!");
               return false;
          }
          
          if(!paramUserObj.iAgree){
               alert("Vui lòng chọn đồng ý với các điều khoản!!!"); 
               return false;
          }
          return true;

     }

     //hàm hiển thị dữ liệu 
     function showData(paramUserObj){
          console.log("Your name: " + paramUserObj.yourName);
          console.log("Your email: " + paramUserObj.yourEmail);
          console.log("Password: " + paramUserObj.password);
          console.log("Repeat password: " + paramUserObj.repeatPassword);
          console.log("IAgree: " + paramUserObj.iAgree);
     } 


 });
     
</script>
</html>